import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.*; 
import processing.core.*; 
import krister.Ess.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 







public class SoundClock extends PApplet {


int window_width = 400;
int window_height = 400;

SoundBox sbox;
SoundWorm worm;

public void setup() 
{
  String default_audio_stream_url = "http://vprclassical.streamguys.net/vprclassical128.mp3";
  try
  {
    default_audio_stream_url = getParameter("audio_stream_url");
  }
  catch(Exception e)
  {
  }
  
  size(window_width, window_height);

  // start ess
  Ess.start(this);

  // prepare radio stream
  sbox = new SoundBox();
  sbox.addStream(default_audio_stream_url);

  frameRate(30);
  smooth();
  
  //create sound worm  
  worm = new SoundWorm(this, width / 2, height / 2, sbox);
  worm.randomizeColors();
  
  // play radio stream
  sbox.playRandomStream();

}

public void draw() 
{
  background(color(255,255,255));
  worm.update();
  worm.display();  
}

public void audioStreamWrite(AudioStream theStream) 
{
  sbox.readNext();
}

// stop ess
public void stop() 
{
   Ess.stop();
   super.stop();
}  

public void mousePressed()
{
  //sbox.playRandomStream();  
  worm.randomizeColors();
}

static public void main(String args[]) {
    PApplet.main("SoundClock");
}

}
